Loading...
Searching...
No Matches
BALL::QSAR::LinearModel Class Reference

`#include <BALL/QSAR/linearModel.h>`

Inheritance diagram for BALL::QSAR::LinearModel:

## Public Member Functions

Constructors and Destructors
| LinearModel (const QSARData &q)
| ~LinearModel ()
virtual void | operator= (const LinearModel &m)
Public Member Functions inherited from BALL::QSAR::RegressionModel
| RegressionModel (const QSARData &q)
| ~RegressionModel ()
virtual EIGEN_MAKE_ALIGNED_OPERATOR_NEW void | operator= (const RegressionModel &m)
const Eigen::MatrixXd * | getTrainingResult () const
virtual void | saveToFile (string filename)
virtual void | readFromFile (string filename)
void | show ()
Public Member Functions inherited from BALL::QSAR::Model
| Model (const QSARData &q)
virtual | ~Model ()
virtual void | operator= (const Model &m)
void | copyData (const Model &m)
void | copyDescriptorIDs (const Model &m)
void | readTrainingData ()
void | deleteDescriptorIDs ()
virtual void | train ()=0
virtual bool | optimizeParameters (int, int)
bool | optimizeParameters (int k)
virtual double | calculateStdErr ()
virtual void | setParameters (vector< double > &)
virtual vector< double > | getParameters () const
std::multiset< unsigned int > * | getDescriptorIDs ()
void | setDataSource (const QSARData *q)
const Eigen::MatrixXd * | getDescriptorMatrix ()
const vector< string > * | getSubstanceNames ()
const vector< string > * | getDescriptorNames ()
const Eigen::MatrixXd | getDescriptorTransformations ()
const Eigen::MatrixXd | getYTransformations ()
const Eigen::MatrixXd * | getY ()
void | setDescriptorIDs (const std::multiset< unsigned int > &sl)
const string * | getType ()
void | getUnnormalizedFeatureValue (int compound, int feature, double &return_value)
void | getUnnormalizedResponseValue (int compound, int response, double &return_value)

## Accessors

virtual Eigen::VectorXd | predict (const vector< double > &substance, bool transform=1)
void | calculateOffsets ()

## Additional Inherited Members

RegressionValidation * | validation
const QSARData * | data
Validation * | model_val
void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation, int no_coefficients)
void | saveDescriptorInformationToFile (std::ofstream &out)
Protected Member Functions inherited from BALL::QSAR::Model
void | readMatrix (Eigen::MatrixXd &mat, std::ifstream &in, unsigned int lines, unsigned int col)
void | readVector (Eigen::RowVectorXd &vec, std::ifstream &in, unsigned int no_cells, bool column_vector)
void | readModelParametersFromFile (std::ifstream &in)
void | saveModelParametersToFile (std::ofstream &out)
virtual void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation)
void | readResponseTransformationFromFile (std::ifstream &in, int no_y)
void | saveResponseTransformationToFile (std::ofstream &out)
Eigen::VectorXd | getSubstanceVector (const vector< double > &substance, bool transform)
Eigen::VectorXd | getSubstanceVector (const Eigen::VectorXd &substance, bool transform)
void | backTransformPrediction (Eigen::VectorXd &pred)
void | addLambda (Eigen::MatrixXd &matrix, double &lambda)
void | readDescriptorInformation ()
Protected Attributes inherited from BALL::QSAR::RegressionModel
Eigen::MatrixXd | training_result_
Eigen::RowVectorXd | offsets_
int | default_no_opt_steps_
Eigen::MatrixXd | descriptor_matrix_
vector< string > | substance_names_
vector< string > | descriptor_names_
Eigen::MatrixXd | descriptor_transformations_
Eigen::MatrixXd | y_transformations_
Eigen::MatrixXd | Y_
String | type_
std::multiset< unsigned int > | descriptor_IDs_

## Detailed Description

Definition at line 17 of file linearModel.h.

## Constructor & Destructor Documentation

## LinearModel()

BALL::QSAR::LinearModel::LinearModel | ( | const QSARData & | q | ) |

constructur,

Parameters

  q | QSAR-wrapper object, from which the data for this model should be taken

## ~LinearModel()

BALL::QSAR::LinearModel::~LinearModel | ( |  | ) |

## Member Function Documentation

## calculateOffsets()

void BALL::QSAR::LinearModel::calculateOffsets | ( |  | ) |

protected virtual

Implements BALL::QSAR::RegressionModel.

## operator=()

virtual void BALL::QSAR::LinearModel::operator= | ( | const LinearModel & | m | ) |

virtual

## predict()

virtual Eigen::VectorXd BALL::QSAR::LinearModel::predict | ( | const vector< double > & | substance,
|  | bool | transform = 1 )

virtual

Predicts the activities of a given substance

Parameters

  substance | the substance which activity is to be predicted in form of a vecor containing the values for all descriptors (if neccessary, relevant descriptors will be selected automatically)

  transform

  determines whether the values for each descriptor of the given substance should be transformed before prediction of activity.
  If (transform==1): each descriptor value is transformed according to the centering of the respective column of QSARData.descriptor_matrix used to train this model.
  If the substance to be predicted is part of the same input data (e.g. same SD-file) as the training data (as is the case during cross validation), transform should therefore be set to 0.

Returns
  a RowVector containing one value for each predicted activity

Implements BALL::QSAR::Model.